import os
#from dotenv import load_dotenv
from flask import Flask, render_template, request, abort
from twilio.jwt.access_token import AccessToken
from twilio.jwt.access_token.grants import VideoGrant, ChatGrant
from twilio.rest import Client
from twilio.base.exceptions import TwilioRestException
import uuid
import requests

#load_dotenv()
twilio_account_sid = "ACa740687333ad8014992f386a8a4b4ea0"
twilio_api_key_sid = "SKc11e4170e8602753a70fb8c11159aa52"
twilio_api_key_secret = "y0XmuI9MFgICe2SHb2jCzpYPocP0MElS"
twilio_client = Client(twilio_api_key_sid, twilio_api_key_secret,
                       twilio_account_sid)

app = Flask(__name__)


def get_chatroom(name):
    for conversation in twilio_client.conversations.conversations.stream():
        if conversation.friendly_name == name:
            return conversation

    # a conversation with the given name does not exist ==> create a new one
    return twilio_client.conversations.conversations.create(
        friendly_name=name)


@app.route('/')
def index():
    return render_template('index.html')


@app.route('/stop')
def stop():
    URL = "http://127.0.0.1:5000/stopServer"
    PARAMS = {'id':"stop"}
    r = requests.get(url = URL, params=PARAMS)
  
    # extracting data in json format
    data = r.json()
    return "0"

@app.route('/login', methods=['POST'])
def login():
    username = request.get_json(force=True).get('username')
    if not username:
        abort(401)

    random = str(uuid.uuid4())
    conversation = get_chatroom(random)
    try:
        conversation.participants.create(identity=username)
    except TwilioRestException as exc:
        # do not error if the user is already in the conversation
        if exc.status != 409:
            raise

    token = AccessToken(twilio_account_sid, twilio_api_key_sid,
                        twilio_api_key_secret, identity=username)
    token.add_grant(VideoGrant(room='My Room'))
    token.add_grant(ChatGrant(service_sid=conversation.chat_service_sid))

    return {'token': token.to_jwt().decode(),
            'conversation_sid': conversation.sid}


if __name__ == '__main__':
    app.run(host='127.0.0.1', port=80)
